Name: git
Version: 1.4.4.4
Release: alt0.M30.1

Summary: Git core and tools
License: GPL
Group: Development/Other
Url: http://kernel.org/pub/software/scm/git/
Packager: Dmitry V. Levin <ldv@altlinux.org>

Source: %name-%version-%release.tar.bz2

%def_enable curl
%def_enable expat
%def_with arch
%def_with cvs
%def_with email
%def_without svn
%def_with tk
%def_with doc
%def_without emacs
%def_with gitweb
%def_without python

Requires: %name-core = %version-%release, %name-server = %version-%release
%{!?_without_arch:Requires: %name-arch = %version-%release}
%{!?_without_cvs:Requires: %name-cvs = %version-%release}
%{!?_without_email:Requires: %name-email = %version-%release}
%{!?_without_svn:Requires: %name-svn = %version-%release}
%{!?_without_tk:Requires: gitk = %version-%release}
%{!?_without_doc:Requires: %name-doc = %version-%release}
%{!?_without_emacs:Requires: emacs-%name = %version-%release}
%{!?_without_gitweb:Requires: gitweb = %version-%release}

BuildRequires: libssl-devel, perl-devel, zlib-devel >= 0:1.2
%{!?_without_python:BuildRequires: python-modules-encodings >= 0:2.4}
%{!?_without_cvs:BuildRequires: perl-DBI}
%{!?_disable_curl:BuildRequires: libcurl-devel}
%{!?_disable_expat:BuildRequires: libexpat-devel}
%{!?_without_email:BuildRequires: perl-Error, perl-Term-ReadLine-Gnu}
%{!?_without_svn:BuildRequires: perl-Memoize, perl-URI, perl-libwww, subversion, subversion-perl, subversion-server-common}
%{!?_without_doc:BuildRequires: asciidoc > 0:6.0.3, xmlto}
%{?!_without_emacs:BuildRequires: emacs-devel, emacs-nox}
%{?!_without_gitweb:BuildRequires: perl-CGI perl-Encode}
%{?!_without_check:%{?!_disable_check:BuildRequires: rcs}}

%description
This is a stupid (but extremely fast) directory content manager.
It doesn't do a whole lot, but what it _does_ do is track directory
contents efficiently.  It is intended to be the base of an efficient,
distributed source code management system.  This package includes
rudimentary tools that can be used as a SCM, but you should look
elsewhere for tools for ordinary humans layered on top of this.

%package core
Summary: Git core tools
Group: Development/Other
Requires: diffstat, less, openssh-clients

%description core
This is a stupid (but extremely fast) directory content manager.
It doesn't do a whole lot, but what it _does_ do is track directory
contents efficiently.  It is intended to be the base of an efficient,
distributed source code management system.  Git itself includes
rudimentary tools that can be used as a SCM, but you should look
elsewhere for tools for ordinary humans layered on top of this.

This package contains core set of Git tools with minimal dependencies.

%package server
Summary: Simple TCP git server for git repositories
Group: System/Servers
Requires: %name-core = %version-%release
PreReq: shadow-utils

%description server
A really simple TCP git server that normally listens on port 9418.
It waits for a connection, and will just execute "git-upload-pack"
when it gets one.  It is ideally suited for read-only updates, i.e.,
pulling from git repositories.

%package arch
Summary: Git tools for importing Arch repositories
Group: Development/Other
Requires: %name-core = %version-%release, tla

%description arch
Git tools for importing Arch repositories.

%package cvs
Summary: Git tools for importing CVS repositories
Group: Development/Other
Requires: %name-core = %version-%release, cvs, cvsps

%description cvs
Git tools for importing CVS repositories.

%package -n perl-Git
Summary: Perl interface to Git
Group: Development/Perl
Requires: %name-core = %version-%release

%description -n perl-Git
Perl interface to Git.

%package email
Summary: Git tools for sending email
Group: Development/Other
Requires: perl-Git = %version-%release

%description email
Git tools for sending email.

%package svn
Summary: Git tools for importing Subversion repositories
Group: Development/Other
Requires: %name-core = %version-%release, subversion

%description svn
Git tools for importing Subversion repositories.

%package -n gitk
Summary: Git revision tree visualiser ('gitk')
Group: Development/Other
Requires: %name-core = %version-%release, tk >= 8.4

%description -n gitk
Git revision tree visualiser ('gitk')

%package -n gitweb
Summary: GIT web interface
Group: Development/Other
Requires: %name-core = %version-%release

%description -n gitweb
Simple web interface to track changes in git repositories.

%package -n libgit-devel
Summary: Git develpoment library and header files
Group: Development/C

%description -n libgit-devel
This package contains libgit.a develpoment library and accompanying
header files.

%package doc
Summary: Git documentation
Group: Development/Documentation
Provides: %name-docs = %version-%release
Obsoletes: %name-docs

%description doc
This package contains the Git documentation in text and HTML formats.

%define pkgdocdir %_docdir/%name-%version

%package -n emacs-%name
Summary: Emacs modes for GIT
Group: Development/Other

%description -n emacs-%name
This package contains Emacs modes for GIT.

%prep
%setup -q -n %name-%version-%release

%build
%make_build CFLAGS="%optflags" prefix=%prefix \
	%{?_disable_curl:NO_CURL=1} \
	%{?_disable_expat:NO_EXPAT=1} \
	%{?_without_python:NO_PYTHON=1 PYMODULES= SCRIPT_PYTHON=} \
	all %{!?_without_doc:doc}
pushd perl
%__rm Makefile
%perl_vendor_build
popd
%{!?_without_emacs:%make_build -C contrib/emacs EMACS=%__emacs}
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%__make -k CFLAGS="%optflags" prefix=%prefix test ||:}}}
%__cc %optflags linkify.c -o linkify

%install
%make_install CFLAGS="%optflags" \
	DESTDIR=%buildroot \
	prefix=%prefix \
	libdir=%_libdir \
	mandir=%_mandir \
	%{?_disable_curl:NO_CURL=1} \
	%{?_disable_expat:NO_EXPAT=1} \
	%{?_without_python:NO_PYTHON=1 PYMODULES= SCRIPT_PYTHON=} \
	install install-lib install-include %{!?_without_doc:install-doc}

pushd perl
%__rm -v "%buildroot$(eval "`%__perl -V:archlib`"; echo "$archlib")"/*
%__rm -vr %buildroot%perl_vendor_archlib
%perl_vendor_install
#%__rm -v %buildroot%_man3dir/*.3pm
popd

# git-server.
%__mkdir_p %buildroot%_sbindir
%__mv %buildroot%_bindir/git-daemon %buildroot%_sbindir/
%__install -pD -m640 git.xinetd \
	%buildroot%_sysconfdir/xinetd.d/git

%if_with gitweb
%__install -pDm755 gitweb/gitweb.cgi %buildroot%_datadir/gitweb/gitweb.cgi
%__install -pm644 gitweb/*.{css,png} gitweb/README \
	%buildroot%_datadir/gitweb/
%endif #gitweb

%if_with emacs
%make_install install -C contrib/emacs emacsdir=%buildroot%_emacslispdir
%__install -pm644 contrib/emacs/*.el %buildroot%_emacslispdir/
%__mkdir_p %buildroot%_emacs_sitestart_dir
%__cat >%buildroot%_emacs_sitestart_dir/git.el <<__EOF
; site-start script for Emacs, initializes git and vc-git
; Evgenii Terechkov, Octember 2006

(require 'git)
(add-to-list 'vc-handled-backends 'GIT)
__EOF
%endif #emacs

# Fix manpages.
find %buildroot%_mandir -type f -print0 |
	xargs -r0 %__subst -p 's/^\(.\+\)\(\.sp\)$/\1\n\2/' --

%{?_without_arch:%__rm -f %buildroot%_bindir/git-archimport}
%{?_without_svn:%__rm -f %buildroot%_bindir/git-svn*}

%__mkdir_p %buildroot%pkgdocdir/
%__cp -a Documentation/*/ %{!?_without_doc:Documentation/*.html} \
	%buildroot%pkgdocdir/

# Avoid compressing templates.
%set_compress_topdir %_mandir

# Hardlink identical files together.
%define __spec_install_custom_post  ./linkify -vc %buildroot

%pre server
/usr/sbin/groupadd -r -f _gitd
/usr/sbin/useradd -r -g _gitd -d /dev/null -s /dev/null -c 'The git server' -n _gitd >/dev/null 2>&1 ||:

%files

%files core
%_bindir/*
%exclude %_bindir/git-cvs*
%exclude %_bindir/gitk
%{!?_without_arch:%exclude %_bindir/git-archimport}
%{!?_without_email:%exclude %_bindir/git-*email*}
%{!?_without_svn:%exclude %_bindir/git-svn*}
%_datadir/git-core/
%if_with doc
%_mandir/man?/*
%exclude %_man1dir/git-daemon.*
%exclude %_man1dir/git-svn*.1*
%exclude %_man1dir/git-cvs*.1*
%exclude %_man1dir/git-archimport.1*
%exclude %_man1dir/git-*email*.1*
%exclude %_man1dir/gitk*.1*
%endif #doc

%files server
%_sbindir/git-daemon
%if_with doc
%_man1dir/git-daemon.*
%endif #doc
%attr(640,root,wheel) %config(noreplace) %_sysconfdir/xinetd.d/git

%if_with arch
%files arch
%_bindir/git-archimport
%if_with doc
%_man1dir/git-archimport.1*
%endif #doc
%endif #arch

%if_with cvs
%files cvs
%_bindir/git-cvs*
%if_with doc
%_man1dir/git-cvs*.1*
%endif #doc
%endif #cvs

%if_with email
%files -n perl-Git
%perl_vendor_privlib/Git.pm

%files email
%_bindir/git-*email*
%if_with doc
%_man1dir/git-*email*.1*
%endif #doc
%endif #email

%if_with svn
%files svn
%_bindir/git-svn*
%if_with doc
%_man1dir/git-svn*.1*
%endif #doc
%endif #svn

%if_with tk
%files -n gitk
%_bindir/gitk
%if_with doc
%_man1dir/gitk.1*
%endif #doc
%endif #tk

%if_with gitweb
%files -n gitweb
%_datadir/gitweb
%endif #gitweb

%files -n libgit-devel
%_libdir/lib*
%_includedir/*

%files doc
%pkgdocdir/

%if_with emacs
%files -n emacs-%name
%_emacs_sitestart_dir/*
%_emacslispdir/*
%endif #emacs

%changelog
* Tue Jan 23 2007 Alexey Borovskoy <alb@altlinux.ru> 1.4.4.4-alt0.M30.1
- New version based on 1.4.4.4-alt1.

* Tue Jan 09 2007 Dmitry V. Levin <ldv@altlinux.org> 1.4.4.4-alt1
- Updated to maint v1.4.4.4.

* Tue Dec 26 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.4.3-alt1
- Updated to maint v1.4.4.3-ge6d40d6.

* Tue Dec 19 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.4.2-alt0.M30.1
- New version based on 1.4.4.2-alt1.

* Mon Dec 18 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.4.2-alt1
- Updated to maint v1.4.4.2-g7da41f4.

* Thu Dec 14 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.4.1-alt0.M30.2
- New version based on 1.4.4.1-alt2.

* Thu Dec 07 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.4.1-alt2
- Updated to maint v1.4.4.1-g562cefb.
- Packaged gitweb subpackage.
- Tweaked templates/ hooks.

* Tue Nov 28 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.4.1-alt0.M30.1
- New version based on 1.4.4.1-alt1.

* Fri Nov 24 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.4.1-alt1
- Updated to maint v1.4.4.1.

* Sun Nov 12 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.5-alt1
- Updated to maint v1.4.3.5.
- Fixed git-archive and git-upload-archive packaging (#10260).
- Made perl interface a separate subpackage.

* Mon Nov 06 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.3.4-alt0.M30.1
- New version based on 1.4.3.4-alt1.
- Disable emacs support.

* Sun Nov 05 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.4-alt1
- Updated to maint v1.4.3.4.
- Packaged emacs modes (#10100).

* Sun Nov 05 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.3.3-alt0.M30.1
- Backport to Compact 3.0.4.

* Thu Nov 02 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.3-alt2
- Updated to maint v1.4.3.3-ge23ed9a.

* Thu Oct 26 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.3-alt1
- Updated to maint v1.4.3.3.

* Tue Oct 24 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.2-alt1
- Updated to maint v1.4.3.2.

* Mon Oct 23 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.1-alt2
- Updated to maint v1.4.3.1-g0abc026.
- Removed git-merge-recursive-old to avoid python requirements.

* Sun Oct 22 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.3.1-alt0.M30.1
- Backport to Compact 3.0.4.

* Sat Oct 21 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3.1-alt1
- Updated to maint v1.4.3.1.
- git-email: Do not package Error.pm (at@).

* Sun Oct 21 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.3-alt0.M30.1
- Backport to Compact 3.0.4.

* Sat Oct 21 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3-alt2
- Updated to maint v1.4.3-gb507b46.
- Packaged libgit.a and accompanying header files.

* Fri Oct 20 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.3-alt1
- Updated to maint v1.4.3-g6b09c78.

* Tue Oct 17 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2.4-alt1
- Updated to maint v1.4.2.4.

* Sun Oct 15 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.2.3-alt0.M30.1
- Backport to Compact 3.0.4.

* Tue Oct 03 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2.3-alt1
- Updated to maint v1.4.2.3.

* Sat Sep 30 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2.2-alt1
- Updated to maint v1.4.2.2.
- Moved git-daemon to separate subpackage git-server,
  added xinetd config file.

* Mon Sep 25 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.2.1-alt0.M30.1
- Backport to Compact 3.0.4.

* Sun Sep 24 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2.1-alt2
- Updated to maint v1.4.2.1-gf2b5792.
- git-tar-tree:
  + Unhardcoded &~022 mode change.
  + Changed default tar_umask to 022.
- git-tag:
  + New option: --full-ref-name, required by gear-release(1).

* Thu Sep 14 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2.1-alt1
- Updated to maint v1.4.2.1.
- core-tutorial, cvs-migration, tutorial-2: Fixed broken links.

* Sun Sep 10 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.2-alt0.M30.2
- Backport to Compact 3.0.4.

* Mon Sep 04 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2-alt2
- count-objects, describe, merge-tree:
  Fixed to make these commands work in subdirectory.
- git, describe, merge-tree:
  Fixed invalid argc handling.
- BuildRequires: Added subversion for svn-enabled build.

* Mon Aug 28 2006 Alexey Borovskoy <alb@altlinux.ru> 1.4.2-alt0.M30.1
- Backport to Compact 3.0.4.
- Disable git-svn.

* Wed Aug 23 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.2-alt1
- Updated to maint v1.4.2-g60a6bf5.
- Changed default pager from `less' to `less -R'.
- Changed default diff.color from `never' to `auto'.

* Tue Aug 15 2006 Dmitry V. Levin <ldv@altlinux.org> 1.4.1.1-alt1
- Updated to 1.4.1.1.

* Thu May 25 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.3-alt3
- hooks--update:
  + Handle the case when git-merge-base fails.
  + Handle mailto file with newlines.

* Fri May 19 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.3-alt2
- Updated to maint be0c7e06.
- Hardlinked identical files together.

* Tue May 16 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.3-alt1
- Updated to 1.3.3.

* Tue May 09 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.2-alt3
- Updated to maint d1802851.

* Mon May 08 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.2-alt2
- Updated to maint 178613c7.
- Updated git-svn from next.
- Separated object name errors from usage errors.
- Package git-svn.

* Thu May 04 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.2-alt1
- Updated to 1.3.2.

* Wed Apr 26 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.1-alt1
- Updated to 1.3.1.

* Wed Apr 19 2006 Dmitry V. Levin <ldv@altlinux.org> 1.3.0-alt1
- Updated to 1.3.0.
- Replaced default templates/hooks--update with my edition.

* Sat Apr 08 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.6-alt1
- Updated to 1.2.6.
- git-tar-tree:
  + Clear S_IWGRP|S_IWOTH bits from permissions in archived files.

* Wed Apr 05 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.5-alt1
- Updated to 1.2.5.

* Mon Mar 13 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.4-alt2
- Avoid compressing templates (#9231).

* Thu Mar 02 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.4-alt1
- Updated to 1.2.4.

* Thu Feb 23 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.3-alt1
- Updated to 1.2.3.

* Mon Feb 20 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.2-alt1
- Updated to 1.2.2.

* Fri Feb 17 2006 Dmitry V. Levin <ldv@altlinux.org> 1.2.1-alt1
- Updated to 1.2.1.

* Tue Feb 14 2006 Dmitry V. Levin <ldv@altlinux.org> 1.1.6-alt2
- Workaround grave bug in docbook-style-xsl to fix generated manpages.
- Packaged manpages within core subpackage.
- Renamed docs -> doc.
- Enabled git core tests during build by default.

* Sat Feb 04 2006 Dmitry V. Levin <ldv@altlinux.org> 1.1.6-alt1
- Updated to 1.1.6.

* Fri Dec 23 2005 Dmitry V. Levin <ldv@altlinux.org> 1.0.3-alt1
- Updated to 1.0.3.

* Sun Dec 04 2005 Dmitry V. Levin <ldv@altlinux.org> 0.99.9l-alt1
- Updated to 0.99.9l.
- Changed subpackage names from git-core-<name> to git-<name>.
- Created empty git package which brings in all subpackages.
- Renamed git-tk to gitk.

* Fri Nov 25 2005 Dmitry V. Levin <ldv@altlinux.org> 0.99.9i-alt1
- Updated to 0.99.9i.
- Modularized and cleaned up specfile.

* Thu Nov 10 2005 Chris Wright <chrisw@osdl.org> 0.99.9g-1
- zlib dependency fix
- Minor cleanups from split
- Move arch import to separate package as well

* Wed Oct 19 2005 Michael Shigorin <mike@altlinux.org> 0.99.8f-alt1
- 0.99.8f (thanks vsu@ for notifying)
- removed WITH_OWN_SUBPROCESS_PY, use python-2.4's

* Wed Oct 19 2005 Michael Shigorin <mike@altlinux.org> 0.99.8e-alt1
- built for ALT Linux
- separate docs subpackage

* Tue Sep 27 2005 Jim Radford <radford@blackbean.org>
- Move programs with non-standard dependencies (svn, cvs, email)
  into separate packages

* Tue Sep 27 2005 H. Peter Anvin <hpa@zytor.com>
- parallelize build
- COPTS -> CFLAGS

* Fri Sep 16 2005 Chris Wright <chrisw@osdl.org> 0.99.6-1
- update to 0.99.6

* Fri Sep 16 2005 Horst H. von Brand <vonbrand@inf.utfsm.cl>
- Linus noticed that less is required, added to the dependencies

* Sun Sep 11 2005 Horst H. von Brand <vonbrand@inf.utfsm.cl>
- Updated dependencies
- Don't assume manpages are gzipped

* Thu Aug 18 2005 Chris Wright <chrisw@osdl.org> 0.99.4-4
- drop sh_utils, sh-utils, diffutils, mktemp, and openssl Requires
- use RPM_OPT_FLAGS in spec file, drop patch0

* Wed Aug 17 2005 Tom "spot" Callaway <tcallawa@redhat.com> 0.99.4-3
- use dist tag to differentiate between branches
- use rpm optflags by default (patch0)
- own %_datadir/git-core/

* Mon Aug 15 2005 Chris Wright <chrisw@osdl.org>
- update spec file to fix Buildroot, Requires, and drop Vendor

* Sun Aug 07 2005 Horst H. von Brand <vonbrand@inf.utfsm.cl>
- Redid the description
- Cut overlong make line, loosened changelog a bit
- I think Junio (or perhaps OSDL?) should be vendor...

* Thu Jul 14 2005 Eric Biederman <ebiederm@xmission.com>
- Add the man pages, and the --without docs build option

* Wed Jul 7 2005 Chris Wright <chris@osdl.org>
- initial git spec file
